Name: brltty
Version: 3.4.1
Release: 1

Group: System Environment/Daemons
License: GPL
Vendor: The BRLTTY Team
Packager: Dave Mielke <dave@mielke.cc>
URL: http://mielke.cc/brltty/
Source: http://mielke.cc/brltty/releases/%{name}-%{version}.tar.gz

BuildRequires: autoconf >= 2.53
BuildRequires: make
BuildRequires: gcc
BuildRequires: /bin/sh
BuildRequires: /bin/ln
BuildRequires: /usr/bin/ld
BuildRequires: /sbin/ldconfig
BuildRequires: /usr/bin/ranlib
BuildRequires: /usr/bin/ar
BuildRequires: /usr/bin/awk
BuildRequires: /usr/bin/bison
BuildRequires: /usr/bin/install
BuildRequires: glibc-devel

BuildRoot: %{_tmppath}/%{name}-%{version}-InstallRoot
%define _bindir /bin
%define _sbindir /sbin
%define _libdir /lib
%define _sysconfdir /etc

AutoProv: 1

AutoReq: 1
Requires: /bin/sh

Summary: Braille display driver for Linux/Unix.
%description
BRLTTY is a background process (daemon) which provides access to the
Linux/Unix console (when in text mode) for a blind person using a
refreshable braille display.  It drives the braille display, and
provides complete screen review functionality.  Some speech capability
has also been incorporated.

Install this package if you use a refreshable braille display.

%package -n brlapi
Version: 0.1.1
Group: Applications/System

AutoProv: 1

AutoReq: 1

Summary: Appliation Programming Interface for BRLTTY.
%description -n brlapi
This package provides the run-time support for the Application
Programming Interface to BRLTTY.

Install this package if you have an application which directly accesses
a refreshable braille display.

%package -n brlapi-devel
Version: 0.1.1
Group: Development/System

AutoProv: 1

AutoReq: 1
Requires: brlapi = 0.1.1

Summary: Headers, static archive, and documentation for BrlAPI.
%description -n brlapi-devel
This package provides the header files, static archive, shared object
linker reference, and reference documentation for BrlAPI (the
Application Programming Interface to BRLTTY).  It enables the
implementation of applications which take direct advantage of a
refreshable braille display in order to present information in ways
which are more appropriate for blind users and/or to provide user
interfaces which are more specifically atuned to their needs.

Install this package if you're developing or maintaining an application
which directly accesses a refreshable braille display.

%prep
# %setup -n %{name}-%{version}
%setup -n brltty-3.4.1

%build
%configure --with-install-root="${RPM_BUILD_ROOT}" --without-flite --without-theta --without-viavoice
make

directory="doc"
mkdir -p "${directory}"
for file in `find . \( -path "./${directory}" -o -path ./Documents \) -prune -o \( -name 'README*' -o -name '*.patch' -o -name '*.txt' -o -name '*.html' -o -name '*.sgml' -o \( -path "./Bootdisks/*" -type f -perm +ugo=x \) \) -print`
do
   mkdir -p "${directory}/${file%/*}"
   cp -rp "${file}" "${directory}/${file}"
done

%install
make install
install -m 644 Documents/brltty.conf "${RPM_BUILD_ROOT}%{_sysconfdir}"

%clean
rm -fr "${RPM_BUILD_ROOT}"

%files
%defattr(-,root,root)
%{_bindir}/brltty
%{_bindir}/brltty-*
%{_libdir}/brltty
%{_sysconfdir}/brltty
%doc %{_mandir}/man1/*
%doc Documents/Manual.sgml Documents/Manual.txt Documents/Manual-HTML
%doc COPYING
%doc Documents/ChangeLog Documents/TODO
%doc doc/*
%config(noreplace) %verify(not size md5 mtime) %{_sysconfdir}/brltty.conf

%files -n brlapi
%defattr(-,root,root)
%{_libdir}/libbrlapi.so.*
%doc Documents/BrlAPI.sgml Documents/BrlAPI.txt Documents/BrlAPI-HTML
%doc Documents/README.Gnopernicus

%files -n brlapi-devel
%defattr(-,root,root)
%{_libdir}/libbrlapi.a
%{_libdir}/libbrlapi.so
%{_includedir}/brltty
%doc %{_mandir}/man3/*
%doc Documents/BrlAPIref-HTML

%pre
# The pre-install scriptlet.

# If a configuration file already exists then rpm installs the new one as
# <path>.rpmnew. If this is done then the .rpmnew file is overwritten if it
# already exists.

# There's no explicit way to tell if a configuration file has been installed
# as itself or as a .rpmnew file. The way we'll figure it out, therefore, is by
# erasing the .rpmnew file now so that we can see if it gets created later. 
rm -f "%{_sysconfdir}/brltty.conf.rpmnew"

%post
# The post-install scriptlet.

# If BRLTTY's boot parameter has been specified then update the just installed
# configuration file template to reflect the options supplied thereby.

# First, we need to determine which file to update. If there's a .rpmnew file
# then update it since a previous configuration file must already have existed.
file="%{_sysconfdir}/brltty.conf"
new="${file}.rpmnew"
[ -f "${new}" ] && file="${new}"

# Update the configuration file template via the Bootdisks/bp2cf script.
# Include it right within this scriptlet so that it needn't be installed.
# Imbed it within a subshell to ensure that it won't impact this scriptlet.
(
   # First, set bp2cf's command line arguments.
   set -- -u -f "${file}"

   # Now run it by simply imbedding it right here.
   
#!/bin/sh
###############################################################################
# BRLTTY - A background process providing access to the Linux console (when in
#          text mode) for a blind person using a refreshable braille display.
#
# Copyright (C) 1995-2003 by The BRLTTY Team. All rights reserved.
#
# BRLTTY comes with ABSOLUTELY NO WARRANTY.
#
# This is free software, placed under the terms of the
# GNU General Public License, as published by the Free Software
# Foundation.  Please see the file COPYING for details.
#
# Web Page: http://mielke.cc/brltty/
#
# This software is maintained by Dave Mielke <dave@mielke.cc>.
###############################################################################

# Convert the boot parameter to configuration file directives.
# If /proc is mounted then use the brltty= boot parameter in /proc/cmdline.
# If /proc is not mounted then use the brltty environment variable.
# Invoke with -h for usage information.

programName="${0##*/}"
programMessage()
{
   echo 2>&1 "${programName}: ${1}"
}
syntaxError()
{
   programMessage "${1}"
   exit 2
}
internalError()
{
   programMessage "${1}"
   exit 3
}

configurationFile=""
requestedAction=create
deviceTranslation=none
requestedParameter=""
OPTIND=1
while getopts ":f:cundop:h" option
do
   case "${option}"
   in
      f) configurationFile="${OPTARG}";;
      c) requestedAction=create;;
      u) requestedAction=update;;
      n) deviceTranslation=none;;
      d) deviceTranslation=devfs;;
      o) deviceTranslation=old;;
      p) requestedParameter="${OPTARG}";;
      h)
         cat <<EOF
Usage: ${programName} [option ...]
-f file  The configuration file to create/update.
-c       Create the configuration file (write to stdout if no -f).
-u       Update the configuration file (copying from stdin to stdout if no -f).
-n       Do not translate device paths.
-d       Do old-style to devfs device path translation.
-o       Do devfs to old-style device path translation.
-p [driver][,[device][,[table]]]
         Explicitly specify the boot parameter.
-h       Display this usage summary.
EOF
         exit 0
         ;;
     \?) syntaxError "unknown option: -${OPTARG}";;
      :) syntaxError "missing value: -${OPTARG}";;
      *) internalError "unimplemented option: -${option}";;
   esac
done
shift "`expr $OPTIND - 1`"
[ "${#}" -eq 0 ] || syntaxError "too many parameters."

case "${requestedAction}"
in
   create)
      putConfigurationLine()
      {
         echo "${1}" || exit 4
      }
      startConfigurationFile()
      {
         [ -n "${configurationFile}" ] && exec >"${configurationFile}"
         putConfigurationLine "`makeHeaderLine Created`"
         putConfigurationLine "`makeParameterLine`"
         putConfigurationLine ""
      }
      putConfigurationDirective()
      {
         putConfigurationLine "${1} ${2}"
      }
      finalizeConfigurationFile()
      {
         :
      }
      ;;
   update)
      putSedCommand()
      {
         sedScript="${sedScript}
${1}"
      }
      startConfigurationFile()
      {
         if [ -n "${configurationFile}" ]
         then
            [ -e "${configurationFile}" ] || syntaxError "file not found: ${configurationFile}"
            [ -f "${configurationFile}" ] || syntaxError "not a file: ${configurationFile}"
            [ -r "${configurationFile}" ] || syntaxError "file not readable: ${configurationFile}"
            [ -w "${configurationFile}" ] || syntaxError "file not writable: ${configurationFile}"
            outputFile="${configurationFile}.new"
            exec <"${configurationFile}" >"${outputFile}"
         fi
         sedScript=""
         putSedCommand "1i\\
`makeHeaderLine Updated`\\
`makeParameterLine`\\
"
      }
      putConfigurationDirective()
      {
         value="`echo "${2}" | sed -e 's%\\([/\\]\\)%\\\\\\1%g'`"
         putSedCommand "/^ *#\\(${1} .*\\)/s//\\1/"
         putSedCommand "/^ *\\(${1}\\) .*/s//\\1 ${value}/"
      }
      finalizeConfigurationFile()
      {
         sed -e "${sedScript}"
         [ -n "${outputFile}" ] && mv -f "${outputFile}" "${configurationFile}"
      }
      ;;
   *) internalError "unimplemented action: ${requestedAction}";;
esac

translateDevice_none()
{
   :
}
translateDevice_devfs()
{
   minor="${device#ttyS}"
   if [ "${minor}" != "${device}" ]
   then
      device="tts/${minor}"
      return 0
   fi
   minor="${device#lp}"
   if [ "${minor}" != "${device}" ]
   then
      device="printers/${minor}"
      return 0
   fi
   programMessage "unsupported old-style device: ${device}"
}
translateDevice_old()
{
   major="${device%%/*}" 
   if [ "${major}" != "${device}" ]
   then
      minor="${device#*/}"
      case "${major}"
      in
         tts) devfs="ttyS${minor}";;
         printers) devfs="lp${minor}";;
      esac
   fi
   if [ -n "${devfs}" ]
   then
      device="${devfs}"
   else
      programMessage "unsupported devfs device: ${device}"
   fi
}

makeHeaderLine()
{
   echo "# ${1} by brltty-bp2cf`date +' on %Y-%m-%d at %H:%M:%S %Z (UTC%z)'`."
}
makeParameterLine()
{
   echo "# Boot Parameter:${bootParameter}"
}
putConfigurationFile()
{
   startConfigurationFile
   [ -n "${brailleDriver}" ] && putConfigurationDirective "braille-driver" "${brailleDriver}"
   [ -n "${brailleDevice}" ] && {
      device="`echo "${brailleDevice}" | sed -e 's%//*%/%g' -e 's%^/dev/%%'`"
      if [ "${device#/}" = "${device}" ]
      then
         translateDevice_${deviceTranslation}
      fi
      putConfigurationDirective "braille-device" "${device}"
   }
   [ -n "${textTable}" ] && putConfigurationDirective "text-table" "${textTable}"
   finalizeConfigurationFile
}
parseBootParameter()
{
   bootParameter="${bootParameter} ${1}"
   number=1
   while [ "${number}" -le 3 ]
   do
      cut="cut -d, -f${number}"
      [ "${number}" -gt 1 ] && cut="${cut} -s"
      operand="`echo ${1} | ${cut}`"
      if [ -n "${operand}" ]
      then
         case "${number}"
         in
            1) brailleDriver="${operand}";;
            2) brailleDevice="${operand}";;
            3) textTable="${operand}";;
         esac
      fi
      number="`expr ${number} + 1`"
   done
}
putBootParameter()
{
   parseBootParameter "${1}"
   putConfigurationFile
}
parseBootCommand()
{
   found=false
   while [ "${#}" -gt 0 ]
   do
      case "${1}"
      in
         "brltty="*)
            found=true
            parseBootParameter "${1#*=}"
            ;;
      esac
      shift
   done
   "${found}" && putConfigurationFile
}

brailleDriver=""
brailleDevice=""
textTable=""
bootCommandFile="/proc/cmdline"
if [ -n "${requestedParameter}" ]
then
   putBootParameter "${requestedParameter}"
elif [ -f "${bootCommandFile}" ]
then
   parseBootCommand `cat "${bootCommandFile}"`
elif [ -n "${brltty}" ]
then
   putBootParameter "${brltty}"
fi
exit 0
)

%changelog
* Thu Jan 15 2004 Dave Mielke <dave@mielke.cc> 3.4.1-1
-  Fix an invalid address conversion. (dm)
-  accept() can return 0. (st)
-  Reset the address length before calling accept(). (st)
-  Pasting accented characters doesn't work. (dm)
-  Only remove brltty-config from Programs during distclean. (ah)
* Wed Dec 31 2003 Dave Mielke <dave@mielke.cc> 3.4-1
-  Remove duplicate files from screen-3.9.11 patch. (TK)
-  Add more build options to specify directories. (dm)
      --with-program-directory
      --with-library-directory
      --with-data-directory
      --with-manpage-directory
      --with-include-directory
-  Swap HandyTech's "freeze screen" [B7] and "six-dot braille" [B6 B8] bindings. (dm)
-  Support HandyTech Modular and Braille Star 80 keypad. (ml)
-  Optional packages are also looked for in /opt/<package-name>. (dm)
-  Configure shouldn't list external drivers when linking statically. (dm)
-  Standardize the software speech driver identification notices. (dm)
-  Support dynamic external, dynamic internal, and static linking for drivers with external dependencies. (dm)
-  spk_open() should return a boolean indicating success or failure. (dm)
-  Add spktest. (dm)
-  Support the Theta text to speech engine. (dm)
-  Add the 4(hundred) to the names of the Alva Delphi models. (dm)
-  Get rid of --disable-tainted-components build option. (dm)
-  Add the --with[out]-viavoice build options. (dm)
-  Remove several unsigned/signed char conflicts. (dm)
-  C90 doesn't permit C++-style // comments. (ml,dm)
-  Support the Festival Lite text to speech engine. (ml)
-  Allow the --with-...-driver= options to take "all" or a comma-delimited list. (dm)
-  The Alva driver shouldn't set CRTSCTS as it prevents some models from displaying output. (dm)
-  Split out HandyTech model identification in preparation for buffer resize support. (dm)
-  Braille drivers providing packet I/O must now implement brl_reset(). (dm)
-  Allow the .tbl extension for attributes translation tables to be optional. (dm)
-  Allow the .ctb extension for contraction tables to be optional. (dm)
-  Support default table extensions and prefixes when configuring. (dm)
-  Disabling contracted braille doesn't fully disable it. (sd,dm)
-  No longer support library names and paths for drivers. (dm)
-  Make private globals static (MiniBraille, Papenmeier, VisioBraille). (dm)
-  Reduce size of BRLPARAMS structure in Avla driver to save space. (ml)
-  Ignore EINTR interruption in Alva's SendToAlva() routine. (ml)
-  Make more private globals static in MultiBraille driver. (ml)
-  Use the TranslationTable typedef in the LogText driver. (ml)
-  EuroBraille driver 1.3.1:
      Corrected AzerBraille 40 Programming keys bugs.
      Added a LOG_IO define to log in/out packets to a file.
      Started to debug Iris identification failures (still not working perfectly).
-  Make private globals static (CombiBraille, MultiBraille). (ml)
-  Make private globals static (EuroBraille, MultiBraille, VideoBraille). (ml)
-  Append the driver code to the driver symbol name. (dm)
-  Convert the VideoBraille driver to use makeOutputTable. (dm)
-  Revive the VarioHT driver. (dm)
-  Fix hanging of Vario driver when display is turned off and on again. (ml)
-  Fix hanging of TSI driver when falling back to 9600 baud. (dm)
-  Convert the EcoBraille driver to use makeOutputTable, openSerialDevice and resetSerialDevice. (dm)
-  Rearrange the t_key structure in the EuroBraille driver to save space. (ml)
-  Convert the MiniBraille driver to use makeOutputTable and openSerialDevice. (dm)
-  Convert the BralleNote driver to use makeOutputTable. (dm)
-  Convert MultiBraille driver to use makeOutputTable, openSerialDevice and resetSerialDevice. (ml,dm)
-  Starting the HandyTech driver gobbles a file descriptor if:
      model detection fails (ml)
      resetting the device fails (dm)
-  Convert the MDV driver to use openSerialDevice and resetSerialDevice. (ml,dm)
-  Convert the VisioBraille driver to use openSerialDevice and resetSerialDevice. (ml,dm)
-  The O_NOCTTY flag shouldn't be used when opening the Voyager device. (dm)
-  Convert the EuroBraille driver to use openSerialDevice and resetSerialDevice. (ml)
-  Convert the Alva driver to use openSerialDevice and resetSerialDevice. (ml,dm)
-  Convert the Vario driver to use openSerialDevice and resetSerialDevice. (ml,dm)
-  Convert the BrailleLite driver to use openSerialDevice and resetSerialDevice. (dm)
-  Replace internal TSI driver SetSpeed() routine with resetSerialDevice(). (ml)
-  Opening a serial device shouldn't hang if CLOCAL isn't set. (dm)
-  Convert the TSI driver to use openSerialDevice(). (dm)
-  Update big5.ctb. (ck)
-  Add the patch for screen-4.0.1. (rb)
-  Add packet I/O to the HandyTech driver. (dm)
-  Changes to support OpenBSD. (ml,dm)
-  Add support for HandyTech's Braillino. (ml,dm)
-  Add a full list of country codes to en-us-g2.ctb as literal. (ml)
-  Implement contraction table opcode 26 (locale). (dm)
-  Document how to use stow to maintain multiple releases of BRLTTY. (bd)
-  brlapi_getControllingTty() now checks back through parent processes until a real tty is found. (ml,dm)
-  Add targets for compiling and uncompiling text translation tables. (ml)
-  Assume a direct-through mapping if there is no screen font map. (ml,dm)
-  Enhance the INIT_PATH mechanism: (np)
      Handle being invoked as linuxrc.
      Handle other commands, e.g. telinit, being ways to invoke init.
-  EuroBraille driver 1.3: (yp)
      Reduced code size.
      BrlAPI compatible.
      Transfer routines moved to separate program.
      Corrected bugs when using an Iris-40 (still not perfect).
-  Change the configure default for BrlAPI to enabled. (dm)
-  Put %config and %verify for brltty.conf on the same line in the rpm spec file. (dm)
-  Delay after receiving a Papenmeier identity packet to allow the display time to become fully ready. (dm)
-  Add the virtual braille display driver. (ml)
-  Introduce brltty-config and use it from brltty-install. (dm)
-  Add CMD_LEARN to the Papenmeier driver. (dm)
-  Allow PRDIFLN/NXDIFLN to move up/down in the preferences menu. (dm)
-  Don't report non-existent directories when uninstalling. (dm)
-  Reduce the log for failure to set the working directory to a warning. (dm)
-  Add / as an additional backup working directory. (dm)
-  Make the directory for driver help, driver configuration, and driver lists specifiable. (dm)
      the -D (--data-directory=) command line option
      the data-directory configuration file directive
      the BRLTTY_DATA_DIRECTORY environment variable
-  Make the directory for text and attributes tables specifiable. (dm)
      the -T (--tables-directory=) command line option
      the tables-directory configuration file directive
      the BRLTTY_TABLES_DIRECTORY environment variable
-  Make the directory for contraction tables specifiable. (dm)
      the -C (--contractions-directory=) command line option
      the contractions-directory configuration file directive
      the BRLTTY_CONTRACTIONS_DIRECTORY environment variable
-  The "braille driver initialization failed" log fills /var when the display isn't connected. (dm)

